/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LAN_H
#define LAN_H

#include "Network.h"

class LAN : public Network
{
public:
	LAN();
	virtual void step();
	virtual void handleMessage(Uint8 msgType, IPaddress address);
	virtual std::string name() const;
	void broadcast();
private:
	virtual void onConnectionTimeout(const IPaddress& addr);
	virtual void refreshAsNeeded();
	
	Uint16 port;
	IPaddress localAddress;
	Uint32 nextBroadcast;
	Uint32 nextBroadcastInterval;
	Uint32 timestamp;
	std::map<IPaddress, Uint32> timestamps;
	
};

const Uint32 MIN_BROADCAST_INTERVAL =  1000; //  1 second
const Uint32 MAX_BROADCAST_INTERVAL = 30000; // 30 seconds

enum
{
	MSG_LAN_BROADCAST = 100,
	MSG_LAN_BROADCAST_ACK
};

#endif
